/*
 * This file is part of the Score-P software (http://www.score-p.org)
 *
 * Copyright (c) 2013,
 * Technische Universitaet Dresden, Germany
 *
 * This software may be modified and distributed under the terms of
 * a BSD-style license.  See the COPYING file in the package base
 * directory for details.
 *
 */

#ifndef CTI_BARRIER_H
#define CTI_BARRIER_H

typedef int pthread_barrierattr_t;

int
pthread_barrierattr_destroy( pthread_barrierattr_t* attr );
int
pthread_barrierattr_init( pthread_barrierattr_t* attr );

typedef struct pthread_barrier
{
    pthread_mutex_t       mutex;
    pthread_cond_t        cond;
    int                   threshold;
    int                   counter;
    int                   cycle;
    int                   valid;
    pthread_barrierattr_t attr;
} pthread_barrier_t;

#define PTHREAD_BARRIER_SERIAL_THREAD -1

int
pthread_barrier_init( pthread_barrier_t*           barrier,
                      const pthread_barrierattr_t* attr,
                      unsigned int                 count );

int
pthread_barrier_destroy( pthread_barrier_t* barrier );

int
pthread_barrier_wait( pthread_barrier_t* barrier );

#endif /* CTI_BARRIER_H */
